// This file is generated by kconfig_compiler_kf5 from kcmaccessibilitymouse.kcfg.
// All changes you do to this file will be lost.
#ifndef MOUSESETTINGS_H
#define MOUSESETTINGS_H

#include <qglobal.h>
#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

class MouseSettings : public KConfigSkeleton
{
  Q_OBJECT
  public:

    MouseSettings( QObject *parent = nullptr );
    ~MouseSettings() override;

    /**
      Set Use keys to control the mouse
    */
    void setMouseKeys( bool v )
    {
      if (v != mMouseKeys && !isMouseKeysImmutable()) {
        mMouseKeys = v;
        Q_EMIT MouseKeysChanged();
      }
    }

    Q_PROPERTY(bool mouseKeys READ mouseKeys WRITE setMouseKeys NOTIFY MouseKeysChanged)
    Q_PROPERTY(bool isMouseKeysImmutable READ isMouseKeysImmutable CONSTANT)
    /**
      Get Use keys to control the mouse
    */
    bool mouseKeys() const
    {
      return mMouseKeys;
    }

    /**
      Is Use keys to control the mouse Immutable
    */
    bool isMouseKeysImmutable() const
    {
      return isImmutable( QStringLiteral( "MouseKeys" ) );
    }

    /**
      Get Use keys to control the mouse default value
    */
    bool defaultMouseKeysValue() const
    {
        return defaultMouseKeysValue_helper();
    }

    /**
      Set Delay for the mouse movement
    */
    void setAccelerationDelay( int v )
    {
      if (v != mAccelerationDelay && !isAccelerationDelayImmutable()) {
        mAccelerationDelay = v;
        Q_EMIT AccelerationDelayChanged();
      }
    }

    Q_PROPERTY(int accelerationDelay READ accelerationDelay WRITE setAccelerationDelay NOTIFY AccelerationDelayChanged)
    Q_PROPERTY(bool isAccelerationDelayImmutable READ isAccelerationDelayImmutable CONSTANT)
    /**
      Get Delay for the mouse movement
    */
    int accelerationDelay() const
    {
      return mAccelerationDelay;
    }

    /**
      Is Delay for the mouse movement Immutable
    */
    bool isAccelerationDelayImmutable() const
    {
      return isImmutable( QStringLiteral( "AccelerationDelay" ) );
    }

    /**
      Get Delay for the mouse movement default value
    */
    int defaultAccelerationDelayValue() const
    {
        return defaultAccelerationDelayValue_helper();
    }

    /**
      Set Repetition interval for the mouse movement
    */
    void setRepetitionInterval( int v )
    {
      if (v != mRepetitionInterval && !isRepetitionIntervalImmutable()) {
        mRepetitionInterval = v;
        Q_EMIT RepetitionIntervalChanged();
      }
    }

    Q_PROPERTY(int repetitionInterval READ repetitionInterval WRITE setRepetitionInterval NOTIFY RepetitionIntervalChanged)
    Q_PROPERTY(bool isRepetitionIntervalImmutable READ isRepetitionIntervalImmutable CONSTANT)
    /**
      Get Repetition interval for the mouse movement
    */
    int repetitionInterval() const
    {
      return mRepetitionInterval;
    }

    /**
      Is Repetition interval for the mouse movement Immutable
    */
    bool isRepetitionIntervalImmutable() const
    {
      return isImmutable( QStringLiteral( "RepetitionInterval" ) );
    }

    /**
      Get Repetition interval for the mouse movement default value
    */
    int defaultRepetitionIntervalValue() const
    {
        return defaultRepetitionIntervalValue_helper();
    }

    /**
      Set Time to hit maximum velocity
    */
    void setMK_TimeToMax( int v )
    {
      if (v != mMK_TimeToMax && !isMK_TimeToMaxImmutable()) {
        mMK_TimeToMax = v;
        Q_EMIT MK_TimeToMaxChanged();
      }
    }

    Q_PROPERTY(int mK_TimeToMax READ mK_TimeToMax WRITE setMK_TimeToMax NOTIFY MK_TimeToMaxChanged)
    Q_PROPERTY(bool isMK_TimeToMaxImmutable READ isMK_TimeToMaxImmutable CONSTANT)
    /**
      Get Time to hit maximum velocity
    */
    int mK_TimeToMax() const
    {
      return mMK_TimeToMax;
    }

    /**
      Is Time to hit maximum velocity Immutable
    */
    bool isMK_TimeToMaxImmutable() const
    {
      return isImmutable( QStringLiteral( "MK_TimeToMax" ) );
    }

    /**
      Get Time to hit maximum velocity default value
    */
    int defaultMK_TimeToMaxValue() const
    {
        return defaultMK_TimeToMaxValue_helper();
    }

    /**
      Set Time to hit maximum velocity
    */
    void setAccelerationTime( int v )
    {
      if (v != mAccelerationTime && !isAccelerationTimeImmutable()) {
        mAccelerationTime = v;
        Q_EMIT AccelerationTimeChanged();
      }
    }

    Q_PROPERTY(int accelerationTime READ accelerationTime WRITE setAccelerationTime NOTIFY AccelerationTimeChanged)
    Q_PROPERTY(bool isAccelerationTimeImmutable READ isAccelerationTimeImmutable CONSTANT)
    /**
      Get Time to hit maximum velocity
    */
    int accelerationTime() const
    {
      return mAccelerationTime;
    }

    /**
      Is Time to hit maximum velocity Immutable
    */
    bool isAccelerationTimeImmutable() const
    {
      return isImmutable( QStringLiteral( "AccelerationTime" ) );
    }

    /**
      Set Maximum velocity
    */
    void setMK_MaxSpeed( int v )
    {
      if (v != mMK_MaxSpeed && !isMK_MaxSpeedImmutable()) {
        mMK_MaxSpeed = v;
        Q_EMIT MK_MaxSpeedChanged();
      }
    }

    Q_PROPERTY(int mK_MaxSpeed READ mK_MaxSpeed WRITE setMK_MaxSpeed NOTIFY MK_MaxSpeedChanged)
    Q_PROPERTY(bool isMK_MaxSpeedImmutable READ isMK_MaxSpeedImmutable CONSTANT)
    /**
      Get Maximum velocity
    */
    int mK_MaxSpeed() const
    {
      return mMK_MaxSpeed;
    }

    /**
      Is Maximum velocity Immutable
    */
    bool isMK_MaxSpeedImmutable() const
    {
      return isImmutable( QStringLiteral( "MK_MaxSpeed" ) );
    }

    /**
      Get Maximum velocity default value
    */
    int defaultMK_MaxSpeedValue() const
    {
        return defaultMK_MaxSpeedValue_helper();
    }

    /**
      Set Maximum Velocity
    */
    void setMaxSpeed( int v )
    {
      if (v != mMaxSpeed && !isMaxSpeedImmutable()) {
        mMaxSpeed = v;
        Q_EMIT MaxSpeedChanged();
      }
    }

    Q_PROPERTY(int maxSpeed READ maxSpeed WRITE setMaxSpeed NOTIFY MaxSpeedChanged)
    Q_PROPERTY(bool isMaxSpeedImmutable READ isMaxSpeedImmutable CONSTANT)
    /**
      Get Maximum Velocity
    */
    int maxSpeed() const
    {
      return mMaxSpeed;
    }

    /**
      Is Maximum Velocity Immutable
    */
    bool isMaxSpeedImmutable() const
    {
      return isImmutable( QStringLiteral( "MaxSpeed" ) );
    }

    /**
      Set Mouse Key Curve
    */
    void setProfileCurve( int v )
    {
      if (v != mProfileCurve && !isProfileCurveImmutable()) {
        mProfileCurve = v;
        Q_EMIT ProfileCurveChanged();
      }
    }

    Q_PROPERTY(int profileCurve READ profileCurve WRITE setProfileCurve NOTIFY ProfileCurveChanged)
    Q_PROPERTY(bool isProfileCurveImmutable READ isProfileCurveImmutable CONSTANT)
    /**
      Get Mouse Key Curve
    */
    int profileCurve() const
    {
      return mProfileCurve;
    }

    /**
      Is Mouse Key Curve Immutable
    */
    bool isProfileCurveImmutable() const
    {
      return isImmutable( QStringLiteral( "ProfileCurve" ) );
    }

    /**
      Get Mouse Key Curve default value
    */
    int defaultProfileCurveValue() const
    {
        return defaultProfileCurveValue_helper();
    }

    /**
      Set Use Gestures
    */
    void setGestures( bool v )
    {
      if (v != mGestures && !isGesturesImmutable()) {
        mGestures = v;
        Q_EMIT GesturesChanged();
      }
    }

    Q_PROPERTY(bool gestures READ gestures WRITE setGestures NOTIFY GesturesChanged)
    Q_PROPERTY(bool isGesturesImmutable READ isGesturesImmutable CONSTANT)
    /**
      Get Use Gestures
    */
    bool gestures() const
    {
      return mGestures;
    }

    /**
      Is Use Gestures Immutable
    */
    bool isGesturesImmutable() const
    {
      return isImmutable( QStringLiteral( "Gestures" ) );
    }

    /**
      Get Use Gestures default value
    */
    bool defaultGesturesValue() const
    {
        return defaultGesturesValue_helper();
    }

    /**
      Set Ask for Confirmation for a gesture
    */
    void setGestureConfirmation( bool v )
    {
      if (v != mGestureConfirmation && !isGestureConfirmationImmutable()) {
        mGestureConfirmation = v;
        Q_EMIT GestureConfirmationChanged();
      }
    }

    Q_PROPERTY(bool gestureConfirmation READ gestureConfirmation WRITE setGestureConfirmation NOTIFY GestureConfirmationChanged)
    Q_PROPERTY(bool isGestureConfirmationImmutable READ isGestureConfirmationImmutable CONSTANT)
    /**
      Get Ask for Confirmation for a gesture
    */
    bool gestureConfirmation() const
    {
      return mGestureConfirmation;
    }

    /**
      Is Ask for Confirmation for a gesture Immutable
    */
    bool isGestureConfirmationImmutable() const
    {
      return isImmutable( QStringLiteral( "GestureConfirmation" ) );
    }

    /**
      Get Ask for Confirmation for a gesture default value
    */
    bool defaultGestureConfirmationValue() const
    {
        return defaultGestureConfirmationValue_helper();
    }

    /**
      Set Confirm access to the Keyboard
    */
    void setKeyboardNotifyAccess( bool v )
    {
      if (v != mKeyboardNotifyAccess && !isKeyboardNotifyAccessImmutable()) {
        mKeyboardNotifyAccess = v;
        Q_EMIT KeyboardNotifyAccessChanged();
      }
    }

    Q_PROPERTY(bool keyboardNotifyAccess READ keyboardNotifyAccess WRITE setKeyboardNotifyAccess NOTIFY KeyboardNotifyAccessChanged)
    Q_PROPERTY(bool isKeyboardNotifyAccessImmutable READ isKeyboardNotifyAccessImmutable CONSTANT)
    /**
      Get Confirm access to the Keyboard
    */
    bool keyboardNotifyAccess() const
    {
      return mKeyboardNotifyAccess;
    }

    /**
      Is Confirm access to the Keyboard Immutable
    */
    bool isKeyboardNotifyAccessImmutable() const
    {
      return isImmutable( QStringLiteral( "KeyboardNotifyAccess" ) );
    }

    /**
      Get Confirm access to the Keyboard default value
    */
    bool defaultKeyboardNotifyAccessValue() const
    {
        return defaultKeyboardNotifyAccessValue_helper();
    }


    enum {
      signalMouseKeysChanged = 0x1,
      signalAccelerationDelayChanged = 0x2,
      signalRepetitionIntervalChanged = 0x4,
      signalMK_TimeToMaxChanged = 0x8,
      signalAccelerationTimeChanged = 0x10,
      signalMK_MaxSpeedChanged = 0x20,
      signalMaxSpeedChanged = 0x40,
      signalProfileCurveChanged = 0x80,
      signalGesturesChanged = 0x100,
      signalGestureConfirmationChanged = 0x200,
      signalKeyboardNotifyAccessChanged = 0x400
    };

  Q_SIGNALS:
    void MouseKeysChanged();

    void AccelerationDelayChanged();

    void RepetitionIntervalChanged();

    void MK_TimeToMaxChanged();

    void AccelerationTimeChanged();

    void MK_MaxSpeedChanged();

    void MaxSpeedChanged();

    void ProfileCurveChanged();

    void GesturesChanged();

    void GestureConfirmationChanged();

    void KeyboardNotifyAccessChanged();

  private:
    void itemChanged(quint64 flags);

  protected:

    // Mouse
    bool mMouseKeys;
    bool defaultMouseKeysValue_helper() const;
    int mAccelerationDelay;
    int defaultAccelerationDelayValue_helper() const;
    int mRepetitionInterval;
    int defaultRepetitionIntervalValue_helper() const;
    int mMK_TimeToMax;
    int defaultMK_TimeToMaxValue_helper() const;
    int mAccelerationTime;
    int defaultAccelerationTimeValue_helper() const;
    int mMK_MaxSpeed;
    int defaultMK_MaxSpeedValue_helper() const;
    int mMaxSpeed;
    int defaultMaxSpeedValue_helper() const;
    int mProfileCurve;
    int defaultProfileCurveValue_helper() const;

    // Keyboard
    bool mGestures;
    bool defaultGesturesValue_helper() const;
    bool mGestureConfirmation;
    bool defaultGestureConfirmationValue_helper() const;
    bool mKeyboardNotifyAccess;
    bool defaultKeyboardNotifyAccessValue_helper() const;

  private:
};

#endif

